#include <bits/stdc++.h>
using namespace std;

class node {
public:
    node* lSide;
    node* rSide;
    set <int> nums;
    int L, R;
    node(int l, int r) {
        lSide = nullptr;
        rSide = nullptr;
        L = l;
        R = r;
    }
};

class SegTree {
private:
    node* root;

    void BuildPrivate(int l, int r, vector <int>& tree, node* n) {
        if (l == r) {
            n -> nums.insert(tree[l]);
        } else {
            n -> lSide = new node(l, (l + r) / 2);
            n -> rSide = new node((l + r) / 2 + 1, r);
            BuildPrivate(l, (l + r) / 2, tree, n -> lSide);
            BuildPrivate((l + r) / 2 + 1, r, tree, n -> rSide);
            for (int num : n -> lSide -> nums)
                n -> nums.insert(num);
            for (int num : n -> rSide -> nums)
                n -> nums.insert(num);
        }

    }

    void GetPrivate(int l, int r, set <int>& temp, node* n) {
        int lTemp = n -> L;
        int rTemp = n -> R;
        if (lTemp >= l && rTemp <= r) {
            for (auto num : n -> nums)
                temp.insert(num);
            return;
        } if (min(lTemp, rTemp) > max(l, r) || max(lTemp, rTemp) < min(l, r))
            return;
        GetPrivate(l, r, temp, n -> lSide);
        GetPrivate(l, r, temp, n -> rSide);
    }

public:

    SegTree() {
        root = nullptr;
    }

    void Build(int l, int r, vector <int>& tree) {
        root = new node(l, r);
        BuildPrivate(l, r, tree, root);
    }

    void Get(int l, int r, set <int>& temp) {
        GetPrivate(l, r, temp, root);
    }

};


int main() {

    int n; cin >> n;
    vector <int> tree(n);

    for (int i = 0; i < n; i++)
        cin >> tree[i];

    SegTree sG;

    sG.Build(0, n - 1, tree);


    for (int i = 1; i <= n; i++) {
        set <int> temp;
        int cnt = 0;
        for (int j = 0; j + i <= n; j++) {
            sG.Get(j, j + i - 1, temp);
            cnt += temp.size();
            temp.clear();
        }
        cout << cnt << " ";
    }

}

